am: Use cat instead of echo to avoid DOS line-endings (fixes t4150)
[git/dscho.git] / git-am.sh
bloba499e147b0598cbbed96d41a61309c7e79abc383
1 #!/bin/sh
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
11 i,interactive run interactively
12 b,binary* (historical option -- no-op)
13 3,3way allow fall back on 3way merging if needed
14 q,quiet be quiet
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flag to git-mailinfo
18 keep-non-patch pass -b flag to git-mailinfo
19 keep-cr pass --keep-cr flag to git-mailsplit for mbox format
20 no-keep-cr do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
21 c,scissors strip everything before a scissors line
22 whitespace= pass it through git-apply
23 ignore-space-change pass it through git-apply
24 ignore-whitespace pass it through git-apply
25 directory= pass it through git-apply
26 exclude= pass it through git-apply
27 C= pass it through git-apply
28 p= pass it through git-apply
29 patch-format= format the patch(es) are in
30 reject pass it through git-apply
31 resolvemsg= override error message when patch failure occurs
32 continue continue applying patches after resolving a conflict
33 r,resolved synonyms for --continue
34 skip skip the current patch
35 abort restore the original branch and abort the patching operation.
36 committer-date-is-author-date lie about committer date
37 ignore-date use current timestamp for author date
38 rerere-autoupdate update the index with reused conflict resolution if possible
39 rebasing* (internal use for git-rebase)"
41 . git-sh-setup
42 . git-sh-i18n
43 prefix=$(git rev-parse --show-prefix)
44 set_reflog_action am
45 require_work_tree
46 cd_to_toplevel
48 git var GIT_COMMITTER_IDENT >/dev/null ||
49 die "$(gettext "You need to set your committer info first")"
51 if git rev-parse --verify -q HEAD >/dev/null
52 then
53 HAS_HEAD=yes
54 else
55 HAS_HEAD=
58 cmdline="git am"
59 if test '' != "$interactive"
60 then
61 cmdline="$cmdline -i"
63 if test '' != "$threeway"
64 then
65 cmdline="$cmdline -3"
68 sq () {
69 git rev-parse --sq-quote "$@"
72 stop_here () {
73 echo "$1" >"$dotest/next"
74 git rev-parse --verify -q HEAD >"$dotest/abort-safety"
75 exit 1
78 safe_to_abort () {
79 if test -f "$dotest/dirtyindex"
80 then
81 return 1
84 if ! test -s "$dotest/abort-safety"
85 then
86 return 0
89 abort_safety=$(cat "$dotest/abort-safety")
90 if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
91 then
92 return 0
94 gettextln "You seem to have moved HEAD since the last 'am' failure.
95 Not rewinding to ORIG_HEAD" >&2
96 return 1
99 stop_here_user_resolve () {
100 if [ -n "$resolvemsg" ]; then
101 printf '%s\n' "$resolvemsg"
102 stop_here $1
104 eval_gettextln "When you have resolved this problem run \"\$cmdline --resolved\".
105 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
106 To restore the original branch and stop patching run \"\$cmdline --abort\"."
108 stop_here $1
111 go_next () {
112 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
113 "$dotest/patch" "$dotest/info"
114 echo "$next" >"$dotest/next"
115 this=$next
118 cannot_fallback () {
119 echo "$1"
120 gettextln "Cannot fall back to three-way merge."
121 exit 1
124 fall_back_3way () {
125 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
127 rm -fr "$dotest"/patch-merge-*
128 mkdir "$dotest/patch-merge-tmp-dir"
130 # First see if the patch records the index info that we can use.
131 cmd="git apply $git_apply_opt --build-fake-ancestor" &&
132 cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
133 eval "$cmd" &&
134 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
135 git write-tree >"$dotest/patch-merge-base+" ||
136 cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
138 say Using index info to reconstruct a base tree...
140 cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
141 cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
142 if eval "$cmd"
143 then
144 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
145 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
146 else
147 cannot_fallback "$(gettext "Did you hand edit your patch?
148 It does not apply to blobs recorded in its index.")"
151 test -f "$dotest/patch-merge-index" &&
152 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
153 orig_tree=$(cat "$dotest/patch-merge-base") &&
154 rm -fr "$dotest"/patch-merge-* || exit 1
156 say "$(gettext "Falling back to patching base and 3-way merge...")"
158 # This is not so wrong. Depending on which base we picked,
159 # orig_tree may be wildly different from ours, but his_tree
160 # has the same set of wildly different changes in parts the
161 # patch did not touch, so recursive ends up canceling them,
162 # saying that we reverted all those changes.
164 eval GITHEAD_$his_tree='"$FIRSTLINE"'
165 export GITHEAD_$his_tree
166 if test -n "$GIT_QUIET"
167 then
168 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
170 git-merge-recursive $orig_tree -- HEAD $his_tree || {
171 git rerere $allow_rerere_autoupdate
172 echo Failed to merge in the changes.
173 exit 1
175 unset GITHEAD_$his_tree
178 clean_abort () {
179 test $# = 0 || cat >&2 <<EOF
182 rm -fr "$dotest"
183 exit 1
186 patch_format=
188 check_patch_format () {
189 # early return if patch_format was set from the command line
190 if test -n "$patch_format"
191 then
192 return 0
195 # we default to mbox format if input is from stdin and for
196 # directories
197 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
198 then
199 patch_format=mbox
200 return 0
203 # otherwise, check the first few non-blank lines of the first
204 # patch to try to detect its format
206 # Start from first line containing non-whitespace
208 while test -z "$l1"
210 read l1 || break
211 done
212 read l2
213 read l3
214 case "$l1" in
215 "From "* | "From: "*)
216 patch_format=mbox
218 '# This series applies on GIT commit'*)
219 patch_format=stgit-series
221 "# HG changeset patch")
222 patch_format=hg
225 # if the second line is empty and the third is
226 # a From, Author or Date entry, this is very
227 # likely an StGIT patch
228 case "$l2,$l3" in
229 ,"From: "* | ,"Author: "* | ,"Date: "*)
230 patch_format=stgit
234 esac
236 esac
237 if test -z "$patch_format" &&
238 test -n "$l1" &&
239 test -n "$l2" &&
240 test -n "$l3"
241 then
242 # This begins with three non-empty lines. Is this a
243 # piece of e-mail a-la RFC2822? Grab all the headers,
244 # discarding the indented remainder of folded lines,
245 # and see if it looks like that they all begin with the
246 # header field names...
247 tr -d '\015' <"$1" |
248 sed -n -e '/^$/q' -e '/^[ ]/d' -e p |
249 sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
250 patch_format=mbox
252 } < "$1" || clean_abort
255 split_patches () {
256 case "$patch_format" in
257 mbox)
258 if test -n "$rebasing" || test t = "$keepcr"
259 then
260 keep_cr=--keep-cr
261 else
262 keep_cr=
264 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
265 clean_abort
267 stgit-series)
268 if test $# -ne 1
269 then
270 clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
272 series_dir=`dirname "$1"`
273 series_file="$1"
274 shift
276 set x
277 while read filename
279 set "$@" "$series_dir/$filename"
280 done
281 # remove the safety x
282 shift
283 # remove the arg coming from the first-line comment
284 shift
285 } < "$series_file" || clean_abort
286 # set the patch format appropriately
287 patch_format=stgit
288 # now handle the actual StGIT patches
289 split_patches "$@"
291 stgit)
292 this=0
293 for stgit in "$@"
295 this=`expr "$this" + 1`
296 msgnum=`printf "%0${prec}d" $this`
297 # Perl version of StGIT parse_patch. The first nonemptyline
298 # not starting with Author, From or Date is the
299 # subject, and the body starts with the next nonempty
300 # line not starting with Author, From or Date
301 perl -ne 'BEGIN { $subject = 0 }
302 if ($subject > 1) { print ; }
303 elsif (/^\s+$/) { next ; }
304 elsif (/^Author:/) { s/Author/From/ ; print ;}
305 elsif (/^(From|Date)/) { print ; }
306 elsif ($subject) {
307 $subject = 2 ;
308 print "\n" ;
309 print ;
310 } else {
311 print "Subject: ", $_ ;
312 $subject = 1;
314 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
315 done
316 echo "$this" > "$dotest/last"
317 this=
318 msgnum=
321 this=0
322 for hg in "$@"
324 this=$(( $this + 1 ))
325 msgnum=$(printf "%0${prec}d" $this)
326 # hg stores changeset metadata in #-commented lines preceding
327 # the commit message and diff(s). The only metadata we care about
328 # are the User and Date (Node ID and Parent are hashes which are
329 # only relevant to the hg repository and thus not useful to us)
330 # Since we cannot guarantee that the commit message is in
331 # git-friendly format, we put no Subject: line and just consume
332 # all of the message as the body
333 perl -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
334 if ($subject) { print ; }
335 elsif (/^\# User /) { s/\# User/From:/ ; print ; }
336 elsif (/^\# Date /) {
337 my ($hashsign, $str, $time, $tz) = split ;
338 $tz = sprintf "%+05d", (0-$tz)/36;
339 print "Date: " .
340 strftime("%a, %d %b %Y %H:%M:%S ",
341 localtime($time))
342 . "$tz\n";
343 } elsif (/^\# /) { next ; }
344 else {
345 print "\n", $_ ;
346 $subject = 1;
348 ' <"$hg" >"$dotest/$msgnum" || clean_abort
349 done
350 echo "$this" >"$dotest/last"
351 this=
352 msgnum=
355 if test -n "$patch_format"
356 then
357 clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
358 else
359 clean_abort "$(gettext "Patch format detection failed.")"
362 esac
365 prec=4
366 dotest="$GIT_DIR/rebase-apply"
367 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
368 resolvemsg= resume= scissors= no_inbody_headers=
369 git_apply_opt=
370 committer_date_is_author_date=
371 ignore_date=
372 allow_rerere_autoupdate=
374 if test "$(git config --bool --get am.keepcr)" = true
375 then
376 keepcr=t
379 while test $# != 0
381 case "$1" in
382 -i|--interactive)
383 interactive=t ;;
384 -b|--binary)
385 echo >&2 "The $1 option has been a no-op for long time, and"
386 echo >&2 "it will be removed. Please do not use it anymore."
388 -3|--3way)
389 threeway=t ;;
390 -s|--signoff)
391 sign=t ;;
392 -u|--utf8)
393 utf8=t ;; # this is now default
394 --no-utf8)
395 utf8= ;;
396 -k|--keep)
397 keep=t ;;
398 --keep-non-patch)
399 keep=b ;;
400 -c|--scissors)
401 scissors=t ;;
402 --no-scissors)
403 scissors=f ;;
404 -r|--resolved|--continue)
405 resolved=t ;;
406 --skip)
407 skip=t ;;
408 --abort)
409 abort=t ;;
410 --rebasing)
411 rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
412 -d|--dotest)
413 die "$(gettext "-d option is no longer supported. Do not use.")"
415 --resolvemsg)
416 shift; resolvemsg=$1 ;;
417 --whitespace|--directory|--exclude)
418 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
419 -C|-p)
420 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
421 --patch-format)
422 shift ; patch_format="$1" ;;
423 --reject|--ignore-whitespace|--ignore-space-change)
424 git_apply_opt="$git_apply_opt $1" ;;
425 --committer-date-is-author-date)
426 committer_date_is_author_date=t ;;
427 --ignore-date)
428 ignore_date=t ;;
429 --rerere-autoupdate|--no-rerere-autoupdate)
430 allow_rerere_autoupdate="$1" ;;
431 -q|--quiet)
432 GIT_QUIET=t ;;
433 --keep-cr)
434 keepcr=t ;;
435 --no-keep-cr)
436 keepcr=f ;;
438 shift; break ;;
440 usage ;;
441 esac
442 shift
443 done
445 # If the dotest directory exists, but we have finished applying all the
446 # patches in them, clear it out.
447 if test -d "$dotest" &&
448 last=$(cat "$dotest/last") &&
449 next=$(cat "$dotest/next") &&
450 test $# != 0 &&
451 test "$next" -gt "$last"
452 then
453 rm -fr "$dotest"
456 if test -d "$dotest"
457 then
458 case "$#,$skip$resolved$abort" in
459 0,*t*)
460 # Explicit resume command and we do not have file, so
461 # we are happy.
462 : ;;
464 # No file input but without resume parameters; catch
465 # user error to feed us a patch from standard input
466 # when there is already $dotest. This is somewhat
467 # unreliable -- stdin could be /dev/null for example
468 # and the caller did not intend to feed us a patch but
469 # wanted to continue unattended.
470 test -t 0
473 false
475 esac ||
476 die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
477 resume=yes
479 case "$skip,$abort" in
480 t,t)
481 die "$(gettext "Please make up your mind. --skip or --abort?")"
484 git rerere clear
485 git read-tree --reset -u HEAD HEAD
486 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
487 git reset HEAD
488 git update-ref ORIG_HEAD $orig_head
491 if test -f "$dotest/rebasing"
492 then
493 exec git rebase --abort
495 git rerere clear
496 if safe_to_abort
497 then
498 git read-tree --reset -u HEAD ORIG_HEAD
499 git reset ORIG_HEAD
501 rm -fr "$dotest"
502 exit ;;
503 esac
504 rm -f "$dotest/dirtyindex"
505 else
506 # Make sure we are not given --skip, --resolved, nor --abort
507 test "$skip$resolved$abort" = "" ||
508 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
510 # Start afresh.
511 mkdir -p "$dotest" || exit
513 if test -n "$prefix" && test $# != 0
514 then
515 first=t
516 for arg
518 test -n "$first" && {
519 set x
520 first=
522 if is_absolute_path "$arg"
523 then
524 set "$@" "$arg"
525 else
526 set "$@" "$prefix$arg"
528 done
529 shift
532 check_patch_format "$@"
534 split_patches "$@"
536 # -i can and must be given when resuming; everything
537 # else is kept
538 echo " $git_apply_opt" >"$dotest/apply-opt"
539 echo "$threeway" >"$dotest/threeway"
540 echo "$sign" >"$dotest/sign"
541 echo "$utf8" >"$dotest/utf8"
542 echo "$keep" >"$dotest/keep"
543 echo "$scissors" >"$dotest/scissors"
544 echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
545 echo "$GIT_QUIET" >"$dotest/quiet"
546 echo 1 >"$dotest/next"
547 if test -n "$rebasing"
548 then
549 : >"$dotest/rebasing"
550 else
551 : >"$dotest/applying"
552 if test -n "$HAS_HEAD"
553 then
554 git update-ref ORIG_HEAD HEAD
555 else
556 git update-ref -d ORIG_HEAD >/dev/null 2>&1
561 git update-index -q --refresh
563 case "$resolved" in
565 case "$HAS_HEAD" in
567 files=$(git ls-files) ;;
569 files=$(git diff-index --ignore-submodules --cached \
570 --name-only HEAD --) ;;
571 esac || exit
572 if test "$files"
573 then
574 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
575 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
577 esac
579 # Now, decide what command line options we will give to the git
580 # commands we invoke, based on the result of parsing command line
581 # options and previous invocation state stored in $dotest/ files.
583 if test "$(cat "$dotest/utf8")" = t
584 then
585 utf8=-u
586 else
587 utf8=-n
589 keep=$(cat "$dotest/keep")
590 case "$keep" in
592 keep=-k ;;
594 keep=-b ;;
596 keep= ;;
597 esac
598 case "$(cat "$dotest/scissors")" in
600 scissors=--scissors ;;
602 scissors=--no-scissors ;;
603 esac
604 if test "$(cat "$dotest/no_inbody_headers")" = t
605 then
606 no_inbody_headers=--no-inbody-headers
607 else
608 no_inbody_headers=
610 if test "$(cat "$dotest/quiet")" = t
611 then
612 GIT_QUIET=t
614 if test "$(cat "$dotest/threeway")" = t
615 then
616 threeway=t
618 git_apply_opt=$(cat "$dotest/apply-opt")
619 if test "$(cat "$dotest/sign")" = t
620 then
621 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
622 s/>.*/>/
623 s/^/Signed-off-by: /'
625 else
626 SIGNOFF=
629 last=`cat "$dotest/last"`
630 this=`cat "$dotest/next"`
631 if test "$skip" = t
632 then
633 this=`expr "$this" + 1`
634 resume=
637 while test "$this" -le "$last"
639 msgnum=`printf "%0${prec}d" $this`
640 next=`expr "$this" + 1`
641 test -f "$dotest/$msgnum" || {
642 resume=
643 go_next
644 continue
647 # If we are not resuming, parse and extract the patch information
648 # into separate files:
649 # - info records the authorship and title
650 # - msg is the rest of commit log message
651 # - patch is the patch body.
653 # When we are resuming, these files are either already prepared
654 # by the user, or the user can tell us to do so by --resolved flag.
655 case "$resume" in
657 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
658 <"$dotest/$msgnum" >"$dotest/info" ||
659 stop_here $this
661 # skip pine's internal folder data
662 sane_grep '^Author: Mail System Internal Data$' \
663 <"$dotest"/info >/dev/null &&
664 go_next && continue
666 test -s "$dotest/patch" || {
667 eval_gettextln "Patch is empty. Was it split wrong?
668 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
669 To restore the original branch and stop patching run \"\$cmdline --abort\"."
670 stop_here $this
672 rm -f "$dotest/original-commit" "$dotest/author-script"
673 if test -f "$dotest/rebasing" &&
674 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
675 -e q "$dotest/$msgnum") &&
676 test "$(git cat-file -t "$commit")" = commit
677 then
678 git cat-file commit "$commit" |
679 sed -e '1,/^$/d' >"$dotest/msg-clean"
680 echo "$commit" > "$dotest/original-commit"
681 get_author_ident_from_commit "$commit" > "$dotest/author-script"
682 else
684 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
685 echo
686 cat "$dotest/msg"
688 git stripspace > "$dotest/msg-clean"
691 esac
693 if test -f "$dotest/author-script"
694 then
695 eval $(cat "$dotest/author-script")
696 else
697 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
698 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
699 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
702 if test -z "$GIT_AUTHOR_EMAIL"
703 then
704 gettextln "Patch does not have a valid e-mail address."
705 stop_here $this
708 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
710 case "$resume" in
712 if test '' != "$SIGNOFF"
713 then
714 LAST_SIGNED_OFF_BY=`
715 sed -ne '/^Signed-off-by: /p' \
716 "$dotest/msg-clean" |
717 sed -ne '$p'
719 ADD_SIGNOFF=`
720 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
721 test '' = "$LAST_SIGNED_OFF_BY" && echo
722 echo "$SIGNOFF"
724 else
725 ADD_SIGNOFF=
728 if test -s "$dotest/msg-clean"
729 then
730 cat "$dotest/msg-clean"
732 if test '' != "$ADD_SIGNOFF"
733 then
734 echo "$ADD_SIGNOFF"
736 } >"$dotest/final-commit"
739 case "$resolved$interactive" in
741 # This is used only for interactive view option.
742 git diff-index --ignore-submodules -p --cached \
743 HEAD -- >"$dotest/patch"
745 esac
746 esac
748 resume=
749 if test "$interactive" = t
750 then
751 test -t 0 ||
752 die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
753 action=again
754 while test "$action" = again
756 gettextln "Commit Body is:"
757 echo "--------------------------"
758 cat "$dotest/final-commit"
759 echo "--------------------------"
760 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
761 # in your translation. The program will only accept English
762 # input at this point.
763 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
764 read reply
765 case "$reply" in
766 [yY]*) action=yes ;;
767 [aA]*) action=yes interactive= ;;
768 [nN]*) action=skip ;;
769 [eE]*) git_editor "$dotest/final-commit"
770 action=again ;;
771 [vV]*) action=again
772 git_pager "$dotest/patch" ;;
773 *) action=again ;;
774 esac
775 done
776 else
777 action=yes
780 if test -f "$dotest/final-commit"
781 then
782 FIRSTLINE=$(sed 1q "$dotest/final-commit")
783 else
784 FIRSTLINE=""
787 if test $action = skip
788 then
789 go_next
790 continue
793 if test -x "$GIT_DIR"/hooks/applypatch-msg
794 then
795 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
796 stop_here $this
799 say "$(eval_gettext "Applying: \$FIRSTLINE")"
801 case "$resolved" in
803 # When we are allowed to fall back to 3-way later, don't give
804 # false errors during the initial attempt.
805 squelch=
806 if test "$threeway" = t
807 then
808 squelch='>/dev/null 2>&1 '
810 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
811 apply_status=$?
814 # Resolved means the user did all the hard work, and
815 # we do not have to do any patch application. Just
816 # trust what the user has in the index file and the
817 # working tree.
818 resolved=
819 git diff-index --ignore-submodules --quiet --cached HEAD -- && {
820 gettextln "No changes - did you forget to use 'git add'?
821 If there is nothing left to stage, chances are that something else
822 already introduced the same changes; you might want to skip this patch."
823 stop_here_user_resolve $this
825 unmerged=$(git ls-files -u)
826 if test -n "$unmerged"
827 then
828 gettextln "You still have unmerged paths in your index
829 did you forget to use 'git add'?"
830 stop_here_user_resolve $this
832 apply_status=0
833 git rerere
835 esac
837 if test $apply_status != 0 && test "$threeway" = t
838 then
839 if (fall_back_3way)
840 then
841 # Applying the patch to an earlier tree and merging the
842 # result may have produced the same tree as ours.
843 git diff-index --ignore-submodules --quiet --cached \
844 HEAD -- && {
845 say "$(gettext "No changes -- Patch already applied.")"
846 go_next
847 continue
849 # clear apply_status -- we have successfully merged.
850 apply_status=0
853 if test $apply_status != 0
854 then
855 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
856 stop_here_user_resolve $this
859 if test -x "$GIT_DIR"/hooks/pre-applypatch
860 then
861 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
864 tree=$(git write-tree) &&
865 commit=$(
866 if test -n "$ignore_date"
867 then
868 GIT_AUTHOR_DATE=
870 parent=$(git rev-parse --verify -q HEAD) ||
871 say >&2 "$(gettext "applying to an empty history")"
873 if test -n "$committer_date_is_author_date"
874 then
875 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
876 export GIT_COMMITTER_DATE
877 fi &&
878 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
879 ) &&
880 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
881 stop_here $this
883 if test -f "$dotest/original-commit"; then
884 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
887 if test -x "$GIT_DIR"/hooks/post-applypatch
888 then
889 "$GIT_DIR"/hooks/post-applypatch
892 go_next
893 done
895 if test -s "$dotest"/rewritten; then
896 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
897 if test -x "$GIT_DIR"/hooks/post-rewrite; then
898 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
902 rm -fr "$dotest"
903 git gc --auto